Shell十三问(二)

作者:網中人
整理:HAWK.Li
原文出处:http://bbs.chinaunix.net/forum/24/20031209/218853.html

简介
ChinaUnix 论坛shell版名为网中人的前辈于2004 年发布的精华贴


《Shell十三问(一)》

-----------------------------------------------------------------------------------------------------------------
9) $@ 与 $* 差在哪?

要说 $@ 与 $* 之前,需得先从 shell script 的 positional parameter 谈起...
我们都已经知道变量(variable)是如何定义及替换的,这个不用再多讲了。
但是,我们还需要知道有些变量是 shell 内定的,且其名称是我们不能随意修改的,
其中就有 positional parameter 在内。

在 shell script 中,我们可用 $0, $1, $2, $3 ... 这样的变量分别提取命令行中的如下部份:


CODE:[Copy to clipboard]script_name parameter1 parameter2 parameter3 ...
我们很容易就能猜出 $0 就是代表 shell script 名称(路径)本身,而 $1 就是其后的第一个参数,如此类推....
须得留意的是 IFS 的作用,也就是,若 IFS 被 quoting 处理后,那么 positional parameter 也会改变。
如下例:


CODE:[Copy to clipboard]my.sh p1 "p2 p3" p4
由于在 p2 与 p3 之间的空格键被 soft quote 所关闭了,因此 my.sh 中的 $2 是 "p2 p3" 而 $3 则是 p4 ...

还记得前两章我们提到 fucntion 时,我不是说过它是 script 中的 script 吗? ^_^
是的,function 一样可以读取自己的(有别于 script 的) postitional parameter ,惟一例外的是 $0 而已。
举例而言:假设 my.sh 里有一个 fucntion 叫 my_fun , 若在 script 中跑 my_fun fp1 fp2 fp3 ,
那么,function 内的 $0 是 my.sh ,而 $1 则是 fp1 而非 p1 了...

不如写个简单的 my.sh script 看看吧:


CODE:[Copy to clipboard]#!/bin/bash

my_fun() {
echo '$0 inside function is '$0
echo '$1 inside function is '$1
echo '$2 inside function is '$2
}

echo '$0 outside function is '$0
echo '$1 outside function is '$1
echo '$2 outside function is '$2

my_fun fp1 "fp2 fp3"
然后在 command line 中跑一下 script 就知道了:


CODE:[Copy to clipboard]chmod +x my.sh
./my.sh p1 "p2 p3"
$0 outside function is ./my.sh
$1 outside function is p1
$2 outside function is p2 p3
$0 inside function is ./my.sh
$1 inside function is fp1
$2 inside function is fp2 fp3
然而,在使用 positional parameter 的时候,我们要注意一些陷阱哦:
* $10 不是替换第 10 个参数,而是替换第一个参数($1)然后再补一个 0 于其后﹗
也就是,my.sh one two three four five six seven eigth nine ten 这样的 command line ,
my.sh 里的 $10 不是 ten 而是 one0 哦... 小心小心﹗
要抓到 ten 的话,有两种方法:

方法一是使用我们上一章介绍的 ${ } ,也就是用 ${10} 即可。

方法二,就是 shift 了。
用通俗的说法来说,所谓的 shift 就是取消 positional parameter 中最左边的参数( $0 不受影响)。
其默认值为 1 ,也就是 shift 或 shift 1 都是取消 $1 ,而原本的 $2 则变成 $1、$3 变成 $2 ...
若 shift 3 则是取消前面三个参数,也就是原本的 $4 将变成 $1 ...
那,亲爱的读者,你说要 shift 掉多少个参数,才可用 $1 取得 ${10} 呢? ^_^

okay,当我们对 positional parameter 有了基本概念之后,那再让我们看看其它相关变量吧。
首先是 $# :它可抓出 positional parameter 的数量。
以前面的 my.sh p1 "p2 p3" 为例:
由于 p2 与 p3 之间的 IFS 是在 soft quote 中,因此 $# 可得到 2 的值。
但如果 p2 与 p3 没有置于 quoting 中话,那 $# 就可得到 3 的值了。
同样的道理在 function 中也是一样的...

因此,我们常在 shell script 里用如下方法测试 script 是否有读进参数:


CODE:[Copy to clipboard][ $# = 0 ]
假如为 0 ,那就表示 script 没有参数,否则就是有带参数...

接下来就是 $@ 与 $* :
精确来讲,两者只有在 soft quote 中才有差异,否则,都表示"全部参数"( $0 除外)。
举例来说好了:
若在 command line 上跑 my.sh p1 "p2 p3" p4 的话,
不管是 $@ 还是 $* ,都可得到 p1 p2 p3 p4 就是了。
但是,如果置于 soft quote 中的话:
"$@" 则可得到 "p1" "p2 p3" "p4" 这三个不同的词段(word)﹔
"$*" 则可得到 "p1 p2 p3 p4" 这一整串单一的词段。

我们可修改一下前面的 my.sh ,使之内容如下:


CODE:[Copy to clipboard]#!/bin/bash

my_fun() {
echo "$#"
}

echo 'the number of parameter in "$@" is '$(my_fun "$@")
echo 'the number of parameter in "$*" is '$(my_fun "$*")
然后再执行 ./my.sh p1 "p2 p3" p4 就知道 $@ 与 $* 差在哪了 ... ^_^

10) && 与 || 差在哪?

好不容易,进入两位数的章节了... 一路走来,很辛苦吧?也很快乐吧? ^_^

在解答本章题目之前,先让我们了解一个概念:return value ﹗
我们在 shell 下跑的每一个 command 或 function ,在结束的时候都会传回父行程一个值,称为 return value 。
在 shell command line 中可用 $? 这个变量得到最"新"的一个 return value ,也就是刚结束的那个行程传回的值。
Return Value(RV) 的取值为 0-255 之间,由程序(或 script)的作者自行定议:
* 若在 script 里,用 exit RV 来指定其值,若没指定,在结束时以最后一道命令之 RV 为值。
* 若在 function 里,则用 return RV 来代替 exit RV 即可。

Return Value 的作用,是用来判断行程的退出状态(exit status),只有两种:
* 0 的话为"真"( true )
* 非 0 的话为"假"( false )

举个例子来说明好了:
假设当前目录内有一份 my.file 的文件,而 no.file 是不存在的:


CODE:[Copy to clipboard]$ touch my.file
$ ls my.file
$ echo $? # first echo
0
$ ls no.file
ls: no.file: No such file or directory
$ echo $? # second echo
1
$ echo $? # third echo
0
上例的第一个 echo 是关于 ls my.file 的 RV ,可得到 0 的值,因此为 true ﹔
第二个 echo 是关于 ls no.file 的 RV ,则得到非 0 的值,因此为 false ﹔
第三个 echo 是关于第二个 echo $? 的 RV ,为 0 的值,因此也为 true 。

请记住:每一个 command 在结束时都会送回 return value 的﹗不管你跑甚么样的命令...
然而,有一个命令却是"专门"用来测试某一条件而送出 return value 以供 true 或 false 的判断,
它就是 test 命令了﹗
若你用的是 bash ,请在 command line 下打 man test 或 man bash 来了解这个 test 的用法。
这是你可用作参考的最精确的文件了,要是听别人说的,仅作参考就好...
下面我只简单作一些辅助说明,其余的一律以 man 为准:

首先,test 的表示式我们称为 expression ,其命令格式有两种:


CODE:[Copy to clipboard]test expression
or:
[ expression ]
(请务必注意 [ ] 之间的空格键﹗)
用哪一种格式没所谓,都是一样的效果。(我个人比较喜欢后者...)

其次,bash 的 test 目前支持的测试对像只有三种:
* string:字符串,也就是纯文字。
* integer:整数( 0 或正整数,不含负数或小数点)。
* file:文件。
请初学者一定要搞清楚这三者的差异,因为 test 所用的 expression 是不一样的。
以 A=123 这个变量为例:
* [ "$A" = 123 ]:是字符串的测试,以测试 $A 是否为 1、2、3 这三个连续的"文字"。
* [ "$A" -eq 123 ]:是整数的测试,以测试 $A 是否等于"一百二十三"。
* [ -e "$A" ]:是关于文件的测试,以测试 123 这份"文件"是否存在。

第三,当 expression 测试为"真"时,test 就送回 0 (true) 的 return value ,否则送出非 0 (false)。
若在 expression 之前加上一个 " ! "(感叹号),则是当 expression 为"假时" 才送出 0 ,否则送出非 0 。
同时,test 也允许多重的覆合测试:
* expression1 -a expression2 :当两个 exrepssion 都为 true ,才送出 0 ,否则送出非 0 。
* expression1 -o expression2 :只需其中一个 exrepssion 为 true ,就送出 0 ,只有两者都为 false 才送出非 0 。
例如:


CODE:[Copy to clipboard][ -d "$file" -a -x "$file" ]
是表示当 $file 是一个目录、且同时具有 x 权限时,test 才会为 true 。

第四,在 command line 中使用 test 时,请别忘记命令行的"重组"特性,
也就是在碰到 meta 时会先处理 meta 再重新组建命令行。(这个特性我在第二及第四章都曾反复强调过)
比方说,若 test 碰到变量或命令替换时,若不能满足 expression 格式时,将会得到语法错误的结果。
举例来说好了:
关于 [ string1 = string2 ] 这个 test 格式,
在 = 号两边必须要有字符串,其中包括空(null)字符串(可用 soft quote 或 hard quote 取得)。
假如 $A 目前没有定义,或被定议为空字符串的话,那如下的写法将会失败:


CODE:[Copy to clipboard]$ unset A
$ [ $A = abc ]
[: =: unary operator expected
这是因为命令行碰到 $ 这个 meta 时,会替换 $A 的值,然后再重组命令行,那就变成了:
[ = abc ]
如此一来 = 号左边就没有字符串存在了,因此造成 test 的语法错误﹗
但是,下面这个写法则是成立的:


CODE:[Copy to clipboard]$ [ "$A" = abc ]
$ echo $?
1
这是因为在命令行重组后的结果为:
[ "" = abc ]
由于 = 左边我们用 soft quote 得到一个空字符串,而让 test 语法得以通过...

读者诸君请务必留意这些细节哦,因为稍一不慎,将会导至 test 的结果变了个样﹗
若您对 test 还不是很有经验的话,那在使用 test 时不妨先采用如下这一个"法则":
* 假如在 test 中碰到变量替换,用 soft quote 是最保险的﹗
若你对 quoting 不熟的话,请重新温习第四章的内容吧... ^_^

okay,关于更多的 test 用法,老话一句:请看 man page 吧﹗ ^_^

虽然洋洋洒洒讲了一大堆,或许你还在嘀咕.... 那... 那个 return value 有啥用啊?﹗
问得好﹗
告诉你:return value 的作用可大了﹗若你想让你的 shell 变"聪明"的话,就全靠它了:
* 有了 return value,我们可以让 shell 跟据不同的状态做不同的时情...

这时候,才让我来揭晓本章的答案吧~~~ ^_^
&& 与 || 都是用来"组建"多个 command line 用的:
* command1 && command2 :其意思是 command2 只有在 RV 为 0 (true) 的条件下执行。
* command1 || command2 :其意思是 command2 只有在 RV 为非 0 (false) 的条件下执行。
来,以例子来说好了:


CODE:[Copy to clipboard]$ A=123
$ [ -n "$A" ] && echo "yes! it's ture."
yes! it's ture.
$ unset A
$ [ -n "$A" ] && echo "yes! it's ture."
$ [ -n "$A" ] || echo "no, it's NOT ture."
no, it's NOT ture.
(注:[ -n string ] 是测试 string 长度大于 0 则为 true 。)
上例的第一个 && 命令行之所以会执行其右边的 echo 命令,是因为上一个 test 送回了 0 的 RV 值﹔
但第二次就不会执行,因为为 test 送回非 0 的结果...
同理,|| 右边的 echo 会被执行,却正是因为左边的 test 送回非 0 所引起的。

事实上,我们在同一命令行中,可用多个 && 或 || 来组建呢:


CODE:[Copy to clipboard]$ A=123
$ [ -n "$A" ] && echo "yes! it's ture." || echo "no, it's NOT ture."
yes! it's ture.
$ unset A
$ [ -n "$A" ] && echo "yes! it's ture." || echo "no, it's NOT ture."
no, it's NOT ture.
怎样,从这一刻开始,你是否觉得我们的 shell 是"很聪明"的呢? ^_^

好了,最后,布置一道习题给大家做做看、、、
下面的判断是:当 $A 被赋与值时,再看是否小于 100 ,否则送出 too big! :


CODE:[Copy to clipboard]$ A=123
$ [ -n "$A" ] && [ "$A" -lt 100 ] || echo 'too big!'
too big!
若我将 A 取消,照理说,应该不会送文字才对啊(因为第一个条件就不成立了)...


CODE:[Copy to clipboard]$ unset A
$ [ -n "$A" ] && [ "$A" -lt 100 ] || echo 'too big!'
too big!
为何上面的结果也可得到呢?
又,如何解决之呢?
(提示:修改方法很多,其中一种方法可利用第七章介绍过的 command group ...)

快﹗告我我答案﹗其余免谈....

11) >; 与 < 差在哪?

这次的题目之前我在 CU 的 shell 版已说明过了:
[url]http://bbs.chinaunix.net/forum/24/20031030/191375.html[/url]
这次我就不重写了,将贴子的内容"抄"下来就是了...

--------------
11.1
谈到 I/O redirection ,不妨先让我们认识一下 File Descriptor (FD) 。

程序的运算,在大部份情况下都是进行数据(data)的处理,
这些数据从哪读进?又,送出到哪里呢?
这就是 file descriptor (FD) 的功用了。

在 shell 程序中,最常使用的 FD 大概有三个,分别为:
0: Standard Input (STDIN)
1: Standard Output (STDOUT)
2: Standard Error Output (STDERR)

在标准情况下,这些 FD 分别跟如下设备(device)关联:
stdin(0): keyboard
stdout(1): monitor
stderr(2): monitor

我们可以用如下下命令测试一下:


CODE:[Copy to clipboard]$ mail -s test root
this is a test mail.
please skip.
^d (同时按 crtl 跟 d 键)
很明显,mail 程序所读进的数据,就是从 stdin 也就是 keyboard 读进的。
不过,不见得每个程序的 stdin 都跟 mail 一样从 keyboard 读进,
因为程序作者可以从档案参数读进 stdin ,如:


CODE:[Copy to clipboard]$ cat /etc/passwd
但,要是 cat 之后没有档案参数则又如何呢?
哦,请您自己玩玩看啰.... ^_^


CODE:[Copy to clipboard]$ cat
(请留意数据输出到哪里去了,最后别忘了按 ^d 离开...)

至于 stdout 与 stderr ,嗯... 等我有空再续吧... ^_^
还是,有哪位前辈要来玩接龙呢?

----------------------------------------------------------------------------------------------------------------------------------
11) >; 与 < 差在哪?

这次的题目之前我在 CU 的 shell 版已说明过了:
[url]http://bbs.chinaunix.net/forum/24/20031030/191375.html[/url]
这次我就不重写了,将贴子的内容"抄"下来就是了...

--------------
11.1
谈到 I/O redirection ,不妨先让我们认识一下 File Descriptor (FD) 。

程序的运算,在大部份情况下都是进行数据(data)的处理,
这些数据从哪读进?又,送出到哪里呢?
这就是 file descriptor (FD) 的功用了。

在 shell 程序中,最常使用的 FD 大概有三个,分别为:
0: Standard Input (STDIN)
1: Standard Output (STDOUT)
2: Standard Error Output (STDERR)

在标准情况下,这些 FD 分别跟如下设备(device)关联:
stdin(0): keyboard
stdout(1): monitor
stderr(2): monitor

我们可以用如下下命令测试一下:


CODE:[Copy to clipboard]$ mail -s test root
this is a test mail.
please skip.
^d (同时按 crtl 跟 d 键)
很明显,mail 程序所读进的数据,就是从 stdin 也就是 keyboard 读进的。
不过,不见得每个程序的 stdin 都跟 mail 一样从 keyboard 读进,
因为程序作者可以从档案参数读进 stdin ,如:


CODE:[Copy to clipboard]$ cat /etc/passwd
但,要是 cat 之后没有档案参数则又如何呢?
哦,请您自己玩玩看啰.... ^_^


CODE:[Copy to clipboard]$ cat
(请留意数据输出到哪里去了,最后别忘了按 ^d 离开...)

至于 stdout 与 stderr ,嗯... 等我有空再续吧... ^_^
还是,有哪位前辈要来玩接龙呢?

--------------
11.2
沿文再续,书接上一回... ^_^

相信,经过上一个练习后,你对 stdin 与 stdout 应该不难理解吧?
然后,让我们继续看 stderr 好了。
事实上,stderr 没甚么难理解的:说穿了就是"错误信息"要往哪边送而已...
比方说,若读进的档案参数是不存在的,那我们在 monitor 上就看到了:


CODE:[Copy to clipboard]$ ls no.such.file
ls: no.such.file: No such file or directory
若,一个命令同时产生 stdout 与 stderr 呢?
那还不简单,都送到 monitor 来就好了:


CODE:[Copy to clipboard]$ touch my.file
$ ls my.file no.such.file
ls: no.such.file: No such file or directory
my.file
okay,至此,关于 FD 及其名称、还有相关联的设备,相信你已经没问题了吧?
那好,接下来让我们看看如何改变这些 FD 的预设数据信道,
我们可用 < 来改变读进的数据信道(stdin),使之从指定的档案读进。
我们可用 >; 来改变送出的数据信道(stdout, stderr),使之输出到指定的档案。

比方说:


CODE:[Copy to clipboard]$ cat < my.file
就是从 my.file 读进数据


CODE:[Copy to clipboard]$ mail -s test root < /etc/passwd
则是从 /etc/passwd 读进...
这样一来,stdin 将不再是从 keyboard 读进,而是从档案读进了...
严格来说,< 符号之前需要指定一个 FD 的(之间不能有空白),
但因为 0 是 < 的默认值,因此 < 与 0< 是一样的﹗

okay,这个好理解吧?
那,要是用两个 << 又是啥呢?
这是所谓的 HERE Document ,它可以让我们输入一段文本,直到读到 << 后指定的字符串。
比方说:


CODE:[Copy to clipboard]$ cat <<FINISH
first line here
second line there
third line nowhere
FINISH
这样的话,cat 会读进 3 行句子,而无需从 keyboard 读进数据且要等 ^d 结束输入。

至于 >; 又如何呢?
且听下回分解....

--------------
11.3
okay,又到讲古时间~~~

当你搞懂了 0< 原来就是改变 stdin 的数据输入信道之后,相信要理解如下两个 redirection 就不难了:
* 1>;
* 2>;
前者是改变 stdout 的数据输出信道,后者是改变 stderr 的数据输出信道。
两者都是将原本要送出到 monitor 的数据转向输出到指定档案去。
由于 1 是 >; 的默认值,因此,1>; 与 >; 是相同的,都是改 stdout 。

用上次的 ls 例子来说明一下好了:


CODE:[Copy to clipboard]$ ls my.file no.such.file 1>;file.out
ls: no.such.file: No such file or directory
这样 monitor 就只剩下 stderr 而已。因为 stdout 给写进 file.out 去了。


CODE:[Copy to clipboard]$ ls my.file no.such.file 2>;file.err
my.file
这样 monitor 就只剩下 stdout ,因为 stderr 写进了 file.err 。


CODE:[Copy to clipboard]$ ls my.file no.such.file 1>;file.out 2>;file.err
这样 monitor 就啥也没有,因为 stdout 与 stderr 都给转到档案去了...

呵~~~ 看来要理解 >; 一点也不难啦﹗是不?没骗你吧? ^_^
不过,有些地方还是要注意一下的。
首先,是 file locking 的问题。比方如下这个例子:


CODE:[Copy to clipboard]$ ls my.file no.such.file 1>;file.both 2>;file.both
从 file system 的角度来说,单一档案在单一时间内,只能被单一的 FD 作写入。
假如 stdout(1) 与 stderr(2) 都同时在写入 file.both 的话,
则要看它们在写入时否碰到同时竞争的情形了,基本上是"先抢先赢"的原则。
让我们用周星驰式的"慢镜头"来看一下 stdout 与 stderr 同时写入 file.out 的情形好了:
* 第 1, 2, 3 秒为 stdout 写入
* 第 3, 4, 5 秒为 stderr 写入
那么,这时候 stderr 的第 3 秒所写的数据就丢失掉了﹗
要是我们能控制 stderr 必须等 stdout 写完再写,或倒过来,stdout 等 stderr 写完再写,那问题就能解决。
但从技术上,较难掌控的,尤其是 FD 在作"长期性"的写入时...

那,如何解决呢?所谓山不转路转、路不转人转嘛,
我们可以换一个思维:将 stderr 导进 stdout 或将 stdout 导进 sterr ,而不是大家在抢同一份档案,不就行了﹗
bingo﹗就是这样啦:
* 2>;&1 就是将 stderr 并进 stdout 作输出
* 1>;&2 或 >;&2 就是将 stdout 并进 stderr 作输出
于是,前面的错误操作可以改为:


CODE:[Copy to clipboard]$ ls my.file no.such.file 1>;file.both 2>;&1

$ ls my.file no.such.file 2>;file.both >;&2
这样,不就皆大欢喜了吗? 呵~~~ ^_^

不过,光解决了 locking 的问题还不够,我们还有其它技巧需要了解的。
故事还没结束,别走开﹗广告后,我们再回来...﹗


--------------
11.4
okay,这次不讲 I/O Redirction ,讲佛吧...
(有没搞错?﹗网中人是否头壳烧坏了?...) 嘻~~~ ^_^

学佛的最高境界,就是"四大皆空"。至于是空哪四大块?我也不知,因为我还没到那境界...
但这个"空"字,却非常值得我们返复把玩的:
--- 色即是空、空即是色﹗
好了,施主要是能够领会"空"的禅意,那离修成正果不远矣~~~

在 linux 档案系统里,有个设备档位于 /dev/null 。
许多人都问过我那是甚么玩意儿?我跟你说好了:那就是"空"啦﹗
没错﹗空空如也的空就是 null 了.... 请问施主是否忽然有所顿误了呢?然则恭喜了~~~ ^_^

这个 null 在 I/O Redirection 中可有用得很呢:
* 若将 FD1 跟 FD2 转到 /dev/null 去,就可将 stdout 与 stderr 弄不见掉。
* 若将 FD0 接到 /dev/null 来,那就是读进 nothing 。
比方说,当我们在执行一个程序时,画面会同时送出 stdout 跟 stderr ,
假如你不想看到 stderr (也不想存到档案去),那可以:


CODE:[Copy to clipboard]$ ls my.file no.such.file 2>;/dev/null
my.file
若要相反:只想看到 stderr 呢?还不简单﹗将 stdout 弄到 null 就行:


CODE:[Copy to clipboard]$ ls my.file no.such.file >;/dev/null
ls: no.such.file: No such file or directory
那接下来,假如单纯只跑程序,不想看到任何输出结果呢?
哦,这里留了一手上次节目没讲的法子,专门赠予有缘人﹗... ^_^
除了用 >;/dev/null 2>;&1 之外,你还可以如此:


CODE:[Copy to clipboard]$ ls my.file no.such.file &>;/dev/null
(提示:将 &>; 换成 >;& 也行啦~~! )

okay?讲完佛,接下来,再让我们看看如下情况:


CODE:[Copy to clipboard]$ echo "1" >; file.out
$ cat file.out
1
$ echo "2" >; file.out
$ cat file.out
2
看来,我们在重导 stdout 或 stderr 进一份档案时,似乎永远只获得最后一次导入的结果。
那,之前的内容呢?
呵~~~ 要解决这个问提很简单啦,将 >; 换成 >;>; 就好:


CODE:[Copy to clipboard]$ echo "3" >;>; file.out
$ cat file.out
2
3
如此一来,被重导的目标档案之内容并不会失去,而新的内容则一直增加在最后面去。
easy ? 呵 ... ^_^

但,只要你再一次用回单一的 >; 来重导的话,那么,旧的内容还是会被"洗"掉的﹗
这时,你要如何避免呢?
----备份﹗ yes ,我听到了﹗不过.... 还有更好的吗?
既然与施主这么有缘份,老纳就送你一个锦囊妙法吧:


CODE:[Copy to clipboard]$ set -o noclobber
$ echo "4" >; file.out
-bash: file: cannot overwrite existing file
那,要如何取消这个"限制"呢?
哦,将 set -o 换成 set +o 就行:


CODE:[Copy to clipboard]$ set +o noclobber
$ echo "5" >; file.out
$ cat file.out
5
再问:那... 有办法不取消而又"临时"盖写目标档案吗?
哦,佛曰:不可告也﹗
啊~~~ 开玩笑的、开玩笑的啦~~~ ^_^ 唉,早就料到人心是不足的了﹗


CODE:[Copy to clipboard]$ set -o noclobber
$ echo "6" >;| file.out
$ cat file.out
6
留意到没有:在 >; 后面再加个" | "就好(注意: >; 与 | 之间不能有空白哦)....

呼.... (深呼吸吐纳一下吧)~~~ ^_^
再来还有一个难题要你去参透的呢:


CODE:[Copy to clipboard]$ echo "some text here" >; file
$ cat < file
some text here
$ cat < file >; file.bak
$ cat < file.bak
some text here
$ cat < file >; file
$ cat < file
嗯?﹗注意到没有?﹗﹗
---- 怎么最后那个 cat 命令看到的 file 竟是空的?﹗
why? why? why?

同学们:下节课不要迟到啰~~~!


--------------
11.5
当当当~~~ 上课啰~~~ ^_^

前面提到:$ cat < file >; file 之后原本有内容的档案结果却被洗掉了﹗
要理解这一现像其实不难,这只是 priority 的问题而已:
* 在 IO Redirection 中,stdout 与 stderr 的管道会先准备好,才会从 stdin 读进资料。
也就是说,在上例中,>; file 会先将 file 清空,然后才读进 < file ,
但这时候档案已经被清空了,因此就变成读不进任何数据了...

哦~~~ 原来如此~~~~ ^_^
那... 如下两例又如何呢?


CODE:[Copy to clipboard]$ cat <>; file
$ cat < file >;>; file
嗯... 同学们,这两个答案就当练习题啰,下节课之前请交作业﹗

好了,I/O Redirection 也快讲完了,sorry,因为我也只知道这么多而已啦~~~ 嘻~~ ^_^
不过,还有一样东东是一定要讲的,各位观众(请自行配乐~!#@!$%) :
---- 就是 pipe line 也﹗

谈到 pipe line ,我相信不少人都不会陌生:
我们在很多 command line 上常看到的" | "符号就是 pipe line 了。
不过,究竟 pipe line 是甚么东东呢?
别急别急... 先查一下英汉字典,看看 pipe 是甚么意思?
没错﹗它就是"水管"的意思...
那么,你能想象一下水管是怎么一根接着一根的吗?
又,每根水管之间的 input 跟 output 又如何呢?
嗯??
灵光一闪:原来 pipe line 的 I/O 跟水管的 I/O 是一模一样的:
* 上一个命令的 stdout 接到下一个命令的 stdin 去了﹗
的确如此... 不管在 command line 上你使用了多少个 pipe line ,
前后两个 command 的 I/O 都是彼此连接的﹗(恭喜:你终于开窍了﹗ ^_^ )

不过... 然而... 但是... ... stderr 呢?
好问题﹗不过也容易理解:
* 若水管漏水怎么办?
也就是说:在 pipe line 之间,前一个命令的 stderr 是不会接进下一命令的 stdin 的,
其输出,若不用 2>; 导到 file 去的话,它还是送到监视器上面来﹗
这点请你在 pipe line 运用上务必要注意的。

那,或许你又会问:
* 有办法将 stderr 也喂进下一个命令的 stdin 去吗?
(贪得无厌的家伙﹗)
方法当然是有,而且你早已学过了﹗ ^_^
我提示一下就好:
* 请问你如何将 stderr 合并进 stdout 一同输出呢?
若你答不出来,下课之后再来问我吧... (如果你脸皮真够厚的话...)

或许,你仍意尤未尽﹗或许,你曾经碰到过下面的问题:
* 在 cm1 | cm2 | cm3 ... 这段 pipe line 中,若要将 cm2 的结果存到某一档案呢?

若你写成 cm1 | cm2 >; file | cm3 的话,
那你肯定会发现 cm3 的 stdin 是空的﹗(当然啦,你都将水管接到别的水池了﹗)
聪明的你或许会如此解决:


CODE:[Copy to clipboard]cm1 | cm2 >; file ; cm3 < file
是的,你的确可以这样做,但最大的坏处是:这样一来,file I/O 会变双倍﹗
在 command 执行的整个过程中,file I/O 是最常见的最大效能杀手。
凡是有经验的 shell 操作者,都会尽量避免或降低 file I/O 的频率。

那,上面问题还有更好方法吗?
有的,那就是 tee 命令了。
* 所谓 tee 命令是在不影响原本 I/O 的情况下,将 stdout 复制一份到档案去。
因此,上面的命令行可以如此打:


CODE:[Copy to clipboard]cm1 | cm2 | tee file | cm3
在预设上,tee 会改写目标档案,若你要改为增加内容的话,那可用 -a 参数达成。

基本上,pipe line 的应用在 shell 操作上是非常广泛的,尤其是在 text filtering 方面,
凡举 cat, more, head, tail, wc, expand, tr, grep, sed, awk, ... 等等文字处理工具,
搭配起 pipe line 来使用,你会惊觉 command line 原来是活得如此精彩的﹗
常让人有"众里寻他千百度,蓦然回首,那人却在灯火阑珊处﹗"之感... ^_^

....

好了,关于 I/O Redirection 的介绍就到此告一段落。
若日后有空的话,再为大家介绍其它在 shell 上好玩的东西﹗bye... ^_^
-------------------------------------------------------------------------------------------------
12) 你要 if 还是 case 呢?

放了一个愉快的春节假期,人也变得懒懒散散的... 只是,答应了大家的作业,还是要坚持完成就是了~~~

还记得我们在第 10 章所介绍的 return value 吗?
是的,接下来介绍的内容与之有关,若你的记忆也被假期的欢乐时光所抵消掉的话,
那,建议您还是先回去温习温习再回来...

若你记得 return value ,我想你也应该记得了 && 与 || 是甚么意思吧?
用这两个符号再配搭 command group 的话,我们可让 shell script 变得更加聪明哦。
比方说:


CODE:[Copy to clipboard]comd1 && {
comd2
comd3
} || {
comd4
comd5
}
意思是说:

假如 comd1 的 return value 为 true 的话,
然则执行 comd2 与 comd3 ,
否则执行 comd4 与 comd5 。


事实上,我们在写 shell script 的时候,经常需要用到这样那样的条件以作出不同的处理动作。
用 && 与 || 的确可以达成条件执行的效果,然而,从"人类语言"上来理解,却不是那么直观。
更多时候,我们还是喜欢用 if .... then ... else ... 这样的 keyword 来表达条件执行。
在 bash shell 中,我们可以如此修改上一段代码:


CODE:[Copy to clipboard]if comd1
then
comd2
comd3
else
comd4
comd5
fi
这也是我们在 shell script 中最常用到的 if 判断式:

只要 if 后面的 command line 返回 true 的 return value (我们最常用 test 命令来送出 return value),
然则就执行 then 后面的命令,否则执行 else 后的命令﹔fi 则是用来结束判断式的 keyword 。


在 if 判断式中,else 部份可以不用,但 then 是必需的。
(若 then 后不想跑任何 command ,可用" : " 这个 null command 代替)。
当然,then 或 else 后面,也可以再使用更进一层的条件判断式,这在 shell script 设计上很常见。
若有多项条件需要"依序"进行判断的话,那我们则可使用 elif 这样的 keyword :


CODE:[Copy to clipboard]if comd1; then
comd2
elif comd3; then
comd4
else
comd5
fi
意思是说:

若 comd1 为 true ,然则执行 comd2 ﹔
否则再测试 comd3 ,然则执行 comd4 ﹔
倘若 comd1 与 comd3 均不成立,那就执行 comd5 。


if 判断式的例子很常见,你可从很多 shell script 中看得到,我这里就不再举例子了...

接下来要为大家介绍的是 case 判断式。
虽然 if 判断式已可应付大部份的条件执行了,然而,在某些场合中,却不够灵活,
尤其是在 string 式样的判断上,比方如下:


CODE:[Copy to clipboard]QQ () {
echo -n "Do you want to continue? (Yes/No): "
read YN
if [ "$YN" = Y -o "$YN" = y -o "$YN" = "Yes" -o "$YN" = "yes" -o "$YN" = "YES" ]
then
QQ
else
exit 0
fi
}
QQ
从例中,我们看得出来,最麻烦的部份是在于判断 YN 的值可能有好几种式样。
聪明的你或许会如此修改:


CODE:[Copy to clipboard]...
if echo "$YN" | grep -q '^[Yy]/([Ee][Ss]/)*$'
...
也就是用 Regular Expression 来简化代码。(我们有机会再来介绍 RE)
只是... 是否有其它更方便的方法呢?
有的,就是用 case 判断式即可:


CODE:[Copy to clipboard]QQ () {
echo -n "Do you want to continue? (Yes/No): "
read YN
case "$YN" in
[Yy]|[Yy][Ee][Ss])
QQ
;;
*)
exit 0
;;
esac
}
QQ
我们常 case 的判断式来判断某一变量在同的值(通常是 string)时作出不同的处理,
比方说,判断 script 参数以执行不同的命令。
若你有兴趣、且用 linux 系统的话,不妨挖一挖 /etc/init.d/* 里那堆 script 中的 case 用法。
如下就是一例:


CODE:[Copy to clipboard]case "$1" in
start)
start
;;
stop)
stop
;;
status)
rhstatus
;;
restart|reload)
restart
;;
condrestart)
[ -f /var/lock/subsys/syslog ] && restart || :
;;
*)
echo $"Usage: $0 {start|stop|status|restart|condrestart}"
exit 1
esac
(若你对 positional parameter 的印像已经模糊了,请重看第 9 章吧。)
---------------------------------------------------------------------------------------------------------
13) for what? while 与 until 差在哪?

终于,来到 shell 十三问的最后一问了... 长长吐一口气~~~~

最后要介绍的是 shell script 设计中常见的"循环"(loop)。
所谓的 loop 就是 script 中的一段在一定条件下反复执行的代码。
bash shell 中常用的 loop 有如下三种:
* for
* while
* until

for loop 是从一个清单列表中读进变量值,并"依次"的循环执行 do 到 done 之间的命令行。
例:


CODE:[Copy to clipboard]for var in one two three four five
do
echo -----------
echo '$var is '$var
echo
done
上例的执行结果将会是:

1) for 会定义一个叫 var 的变量,其值依次是 one two three four five 。
2) 因为有 5 个变量值,因此 do 与 done 之间的命令行会被循环执行 5 次。
3) 每次循环均用 echo 产生三行句子。
而第二行中不在 hard quote 之内的 $var 会依次被替换为 one two three four five 。
4) 当最后一个变量值处理完毕,循环结束。


我们不难看出,在 for loop 中,变量值的多寡,决定循环的次数。
然而,变量在循环中是否使用则不一定,得视设计需求而定。
倘若 for loop 没有使用 in 这个 keyword 来指定变量值清单的话,其值将从 $@ (或 $* )中继承:


CODE:[Copy to clipboard]for var; do
....
done
(若你忘记了 positional parameter ,请温习第 9 章...)

for loop 用于处理"清单"(list)项目非常方便,
其清单除了可明确指定或从 positional parameter 取得之外,
也可从变量替换或命令替换取得... (再一次提醒:别忘了命令行的"重组"特性﹗)
然而,对于一些"累计变化"的项目(如整数加减),for 亦能处理:


CODE:[Copy to clipboard]for ((i=1;i<=10;i++))
do
echo "num is $i"
done
除了 for loop ,上面的例子我们也可改用 while loop 来做到:


CODE:[Copy to clipboard]num=1
while [ "$num" -le 10 ]; do
echo "num is $num"
num=$(($num + 1))
done
while loop 的原理与 for loop 稍有不同:
它不是逐次处理清单中的变量值,而是取决于 while 后面的命令行之 return value :
* 若为 ture ,则执行 do 与 done 之间的命令,然后重新判断 while 后的 return value 。
* 若为 false ,则不再执行 do 与 done 之间的命令而结束循环。

分析上例:

1) 在 while 之前,定义变量 num=1 。
2) 然后测试(test) $num 是否小于或等于 10 。
3) 结果为 true ,于是执行 echo 并将 num 的值加一。
4) 再作第二轮测试,其时 num 的值为 1+1=2 ,依然小于或等于 10,因此为 true ,继续循环。
5) 直到 num 为 10+1=11 时,测试才会失败... 于是结束循环。


我们不难发现:
* 若 while 的测试结果永远为 true 的话,那循环将一直永久执行下去:


CODE:[Copy to clipboard]while :; do
echo looping...
done
上例的" : "是 bash 的 null command ,不做任何动作,除了送回 true 的 return value 。
因此这个循环不会结束,称作死循环。
死循环的产生有可能是故意设计的(如跑 daemon),也可能是设计错误。
若要结束死寻环,可透过 signal 来终止(如按下 ctrl-c )。
(关于 process 与 signal ,等日后有机会再补充,十三问暂时略过。)

一旦你能够理解 while loop 的话,那,就能理解 until loop :
* 与 while 相反,until 是在 return value 为 false 时进入循环,否则结束。
因此,前面的例子我们也可以轻松的用 until 来写:


CODE:[Copy to clipboard]num=1
until [ ! "$num" -le 10 ]; do
echo "num is $num"
num=$(($num + 1))
done
或是:


CODE:[Copy to clipboard]num=1
until [ "$num" -gt 10 ]; do
echo "num is $num"
num=$(($num + 1))
done
okay ,关于 bash 的三个常用的 loop 暂时介绍到这里。
在结束本章之前,再跟大家补充两个与 loop 有关的命令:
* break
* continue
这两个命令常用在复合式循环里,也就是在 do ... done 之间又有更进一层的 loop ,
当然,用在单一循环中也未尝不可啦... ^_^

break 是用来打断循环,也就是"强迫结束" 循环。
若 break 后面指定一个数值 n 的话,则"从里向外"打断第 n 个循环,
默认值为 break 1 ,也就是打断当前的循环。
在使用 break 时需要注意的是, 它与 return 及 exit 是不同的:
* break 是结束 loop
* return 是结束 function
* exit 是结束 script/shell

而 continue 则与 break 相反:强迫进入下一次循环动作。
若你理解不来的话,那你可简单的看成:在 continue 到 done 之间的句子略过而返回循环顶端...
与 break 相同的是:continue 后面也可指定一个数值 n ,以决定继续哪一层(从里向外计算)的循环,
默认值为 continue 1 ,也就是继续当前的循环。

在 shell script 设计中,若能善用 loop ,将能大幅度提高 script 在复杂条件下的处理能力。
请多加练习吧....